// set flex container
@mixin flex($align: null, $justify: null, $direction: null) {
  display: flex;
  align-items: $align;
  justify-content: $justify;
  flex-direction: $direction;
  flex-wrap: wrap;

  > * {
    flex: 0 0 auto;
  }
}

// set overflow ellipsis
@mixin ellipsis {
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
}

// set top/left/bottom/right positions
// top left
@mixin topLeft {
  top: 0;
  left: 0;
}

// top right
@mixin topRight {
  top: 0;
  right: 0;
}

// bottom left
@mixin bottomLeft {
  bottom: 0;
  left: 0;
}

// bottom right
@mixin bottomRight {
  bottom: 0;
  right: 0;
}

// set padding
// set all padding
@mixin padding($padding) {
  box-sizing: border-box;
  padding: $padding;
}

// set padding left
@mixin paddingLeft($padding) {
  box-sizing: border-box;
  padding-left: $padding;
}

// set padding right
@mixin paddingRight($padding) {
  box-sizing: border-box;
  padding-right: $padding;
}

// set padding top
@mixin paddingTop($padding) {
  box-sizing: border-box;
  padding-top: $padding;
}

// set padding bottom
@mixin paddingBottom($padding) {
  box-sizing: border-box;
  padding-bottom: $padding;
}

// set border
// set all border
@mixin border($border) {
  box-sizing: border-box;
  border: $border;
}

// set border left
@mixin borderLeft($border) {
  box-sizing: border-box;
  border-left: $border;
}

// set border right
@mixin borderRight($border) {
  box-sizing: border-box;
  border-right: $border;
}

// set border top
@mixin borderTop($border) {
  box-sizing: border-box;
  border-top: $border;
}

// set border bottom
@mixin borderBottom($border) {
  box-sizing: border-box;
  border-bottom: $border;
}

// create box
@mixin box($size) {
  width: $size;
  height: $size;
}

// create ball
@mixin ball($size) {
  @include box($size);
  border-radius: 50%;
}

// set full screen
@mixin fullScreen {
  @include box(100%);
  @include topLeft;
}

// custom attribute mixin
@mixin customAttribute($attr, $value) {
  &[app-#{$attr}='#{$value}'] {
    @content;
  }
}

// set width between gaps
@mixin widthBetweenGap($gap, $count) {
  width: calc((100% - (#{$gap} * #{$count - 1})) / #{$count});
  margin-right: $gap;

  &:nth-child(#{$count}n) {
    margin-right: 0;
  }
}

// set multiple widths
@mixin setMultipleWidths($widths) {
  $i: 1;

  @each $width in $widths {
    &:nth-child(#{$i}) {
      width: $width;
    }

    $i: $i + 1;
  }
}

// set multiple minimum widths
@mixin setMultipleMinWidths($widths) {
  $i: 1;

  @each $width in $widths {
    &:nth-child(#{$i}) {
      min-width: $width;
    }

    $i: $i + 1;
  }
}

// colomn order in mobile
@mixin setMultipleOrder($orders) {
  $i: 1;

  @each $order in $orders {
    &:nth-child(#{$i}) {
      order: $order;
    }

    $i: $i + 1;
  }
}

// arrows
// default
@mixin arrowDefault {
  &::after {
    content: '';
    height: 0;
    width: 0;
    position: absolute;
    pointer-events: none;
    @content;
  }
}

// top
@mixin topArrow($size, $color) {
  @include arrowDefault {
    bottom: 100%;
    left: 50%;
    border: solid $size transparent;
    border-bottom-color: $color;
    margin-left: -$size;
  }
}

// left
@mixin leftArrow($size, $color) {
  @include arrowDefault {
    right: 100%;
    top: 50%;
    border: solid $size transparent;
    border-right-color: $color;
    margin-top: -$size;
  }
}

// bottom
@mixin bottomArrow($size, $color) {
  @include arrowDefault {
    top: 100%;
    left: 50%;
    border: solid $size transparent;
    border-top-color: $color;
    margin-left: -$size;
  }
}

// right
@mixin rightArrow($size, $color) {
  @include arrowDefault {
    left: 100%;
    top: 50%;
    border: solid $size transparent;
    border-left-color: $color;
    margin-top: -$size;
  }
}

// fonts
// ubuntu
@mixin ubuntuRegular {
  font-family: 'Ubuntu', sans-serif;
  font-weight: 400;
}

@mixin ubuntuMedium {
  font-family: 'Ubuntu', sans-serif;
  font-weight: 500;
}

@mixin ubuntuBold {
  font-family: 'Ubuntu', sans-serif;
  font-weight: 700;
}

// roboto
@mixin robotoRegular {
  font-family: 'Roboto', sans-serif;
  font-weight: 400;
}

@mixin robotoMedium {
  font-family: 'Roboto', sans-serif;
  font-weight: 500;
}

@mixin robotoBold {
  font-family: 'Roboto', sans-serif;
  font-weight: 700;
}

// poppins
@mixin poppinsRegular {
  font-family: 'Poppins', sans-serif;
  font-weight: 400;
}
